<?php
namespace Shopware\trus1TrustedShopsBadge\Subscriber;
use Enlight\Event\SubscriberInterface;
use Enlight_Event_EventArgs;

/**
 * Class Backend
 *
 * @package Shopware\trus1TrustedShopsBadge\Subscriber
 * @author    Trusted Shops GmbH
 * @copyright 2017 Trusted Shops GmbH
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 * @link      http://www.trustedshops.de/
 */
class Backend implements SubscriberInterface
{

    /**
     * @var $pathVar
     */
    private $pathVar;

    /**
     * initialises the bootstrapPath variable
     *
     * @param $pathVar
     */
    public function __construct($pathVar)
    {
        $this->pathVar = $pathVar;
    }

    /**
     * Returns an array of event names this subscriber wants to listen to.
     *
     * @return array The event names to listen to
     */
    public static function getSubscribedEvents()
    {
        return array(
            'Enlight_Controller_Action_PostDispatchSecure_Backend_Index' => 'onPostDispatchIndex'
        );
    }

    /**
     * Provides the Trusted Shops logo in the backend
     *
     * @param Enlight_Event_EventArgs $args
     */
    public function onPostDispatchIndex(Enlight_Event_EventArgs $args)
    {
        /* @var \Enlight_Controller_Action $subject */
        $subject = $args->getSubject();
        $view = $subject->View();

        $view->addTemplateDir($this->pathVar . 'Views/');
        $view->extendsTemplate('backend/trusted_shops_badge/menu_entry.tpl');
    }
}
