
//{namespace name="trusted_shops_badge"}

//{block name="backend/trusted_shops_badge/view/main/badge"}
Ext.define('Shopware.apps.TrustedShopsBadge.view.main.Badge', {
    extend: 'Ext.container.Container',
    alias: 'widget.trustedShops-main-badge',
    id: 'tsBadgePanel',
    itemId: 'tsBadgePanel',
    layout: 'anchor',
    padding: 10,
    defaults: {
        anchor: '100%',
        labelWidth: 200
    },

    /**
     * Contains all snippets for Standard mode tab
     * @object
     */
    snippets: {
        trustedShopsTrustBadgeCodeEmptyText: '{s name=badge/trustedShopsTrustBadgeCodeEmptyText}{/s}',
        inStockDeliveryTime: '{s name=badge/inStockDeliveryTime}{/s}',
        notInStockDeliveryTime: '{s name=badge/notInStockDeliveryTime}{/s}',
        prodReviewStickerSwitch: '{s name=badge/prodReviewStickerSwitch}{/s}',
        prodReviewStarsSwitch: '{s name=badge/prodReviewStarsSwitch}{/s}',
        prodReviewStickerTitle: '{s name=badge/prodReviewStickerTitle}{/s}',
        prodReviewStarsTitle: '{s name=badge/prodReviewStarsTitle}{/s}',
        prodReviewStickerStarColor: '{s name=badge/prodReviewStickerStarColor}{/s}',
        prodReviewStickerBorderColor: '{s name=badge/prodReviewStickerBorderColor}{/s}',
        prodReviewStarColor: '{s name=badge/prodReviewStarColor}{/s}',
        prodReviewStarSize: '{s name=badge/prodReviewStarSize}{/s}',
        prodReviewFontSize: '{s name=badge/prodReviewFontSize}{/s}',
        deliveryTimeTitle: '{s name=badge/deliveryTimeTitle}{/s}',
        prodReviewStickerTabName: '{s name=badge/prodReviewStickerTabName}{/s}',
        badgeVariantLabel: '{s name=badge/badgeVariantLabel}{/s}',
        hideEmptyStarRatingsLabel: '{s name=badge/hideEmptyStarRatingsLabel}{/s}',
        trustBadgeLabel: '{s name=badge/trustBadgeLabel}{/s}',
        yOffset: '{s name=badge/yOffset}{/s}',
        tsVariantWithoutStarsOption: '{s name=badge/tsVariantDefaultOption}{/s}',
        tsVariantWithStarsOption: '{s name=badge/tsVariantWithStarsOption}{/s}',
        tsVariantNoBadgeOption: '{s name=badge/tsVariantNoBadgeOption}{/s}',
        yesComboOption: '{s name=badge/yesComboOption}{/s}',
        noComboOption: '{s name=badge/noComboOption}{/s}',
        yOffsetHelpText: '{s name=badge/yOffsetHelpText}{/s}',
        collectRatingsFieldset: '{s name=badge/collectRatingsFieldset}{/s}',
        collectRatingsLabel: '{s name=badge/collectRatingsLabel}{/s}',
        collectRatingsDescription: '{s name=badge/collectRatingsDescription}{/s}',
        inStockDeliveryTimeHelpText: '{s name=badge/inStockDeliveryTimeHelpText}{/s}',
        notInStockDeliveryTimeHelpText: '{s name=badge/notInStockDeliveryTimeHelpText}{/s}',
        emptyStarsHelpText: '{s name=badge/emptyStarsHelpText}{/s}',
        prodReviewStickerBackgroundColor: '{s name=badge/prodReviewStickerBackgroundColor}{/s}',
        prodReviewStickerStarSize: '{s name=badge/prodReviewStickerStarSize}{/s}',
        deliveryTimeSettingsAvailableProduct: '{s name=badge/deliveryTimeSettingsAvailableProduct}{/s}',
        deliveryTimeSettingsNAProduct: '{s name=badge/deliveryTimeSettingsNAProduct}{/s}',
        deliveryTimeAsDefined: '{s name=badge/deliveryTimeAsDefined}{/s}',
        fixedDeliveryTime: '{s name=badge/fixedDeliveryTime}{/s}',
        customerRatingsLabel: '{s name=badge/customerRatingsLabel}{/s}',
        customerRatingsActive: '{s name=badge/customerRatingsActive}{/s}',
        customerRatingsExtratext: '{s name=badge/customerRatingsExtratext}{/s}',
        customerRatingsFontFamily: '{s name=badge/customerRatingsFontFamily}{/s}',
        customerRatingsReviews: '{s name=badge/customerRatingsReviews}{/s}',
        customerRatingsBetterThan: '{s name=badge/customerRatingsBetterThan}{/s}',
        customerRatingsBackgroundColor: '{s name=badge/customerRatingsBackgroundColor}{/s}',
        richSnippets: '{s name=badge/richSnippets}{/s}',
        richSnippetsActive: '{s name=badge/richSnippetsActive}{/s}',
        richSnippetsCategory: '{s name=badge/richSnippetsCategory}{/s}',
        richSnippetsProduct: '{s name=badge/richSnippetsProduct}{/s}',
        richSnippetsHome: '{s name=badge/richSnippetsHome}{/s}',
        richSnippetsHelpText: '{s name=badge/richSnippetsHelpText}{/s}',
        richSnippetsOn: '{s name=badge/richSnippetsOn}{/s}',
        configureMoreProductsFieldsetTitle: '{s name=badge/configureMoreProductsFieldsetTitle}{/s}',
        prodReviewStickerTabNameHelpText: '{s name=badge/prodReviewStickerTabNameHelpText}{/s}'
    },

    /**
     * Initializing the User Interface
     *
     * @return void
     */
    initComponent: function () {
        var me = this;
        me.items = me.getItems();
        me.callParent(arguments);
    },

    /**
     * Creating items for the standard Mode panel
     *
     * @return array
     */
    getItems: function () {
        var me = this,
            badgeVariant = Ext.create('Ext.data.Store', {
                fields: [
                    'variantVal',
                    'variantText'
                ],
                data: [
                    { variantVal: 'hide', variantText: me.snippets.tsVariantNoBadgeOption },
                    { variantVal: 'default', variantText: me.snippets.tsVariantWithoutStarsOption },
                    { variantVal: 'reviews', variantText: me.snippets.tsVariantWithStarsOption }
                ]
            }),
            collectRatingsStore = Ext.create('Ext.data.Store', {
                fields: [
                    'variantVal',
                    'variantText'
                ],
                data: [
                    { variantVal: true, variantText: me.snippets.yesComboOption },
                    { variantVal: false, variantText: me.snippets.noComboOption }

                ]
            }),
            showRating = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': true, 'text': me.snippets.yesComboOption },
                    { 'val': false, 'text': me.snippets.noComboOption }

                ]
            }),
            showStars = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': true, 'text': me.snippets.yesComboOption },
                    { 'val': false, 'text': me.snippets.noComboOption }
                ]
            }),
            activateCustomerRatings = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': true, 'text': me.snippets.yesComboOption },
                    { 'val': false, 'text': me.snippets.noComboOption }
                ]
            }),
            fontsStore = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': 'Arial', 'text': 'Arial' },
                    { 'val': 'Geneva', 'text': 'Geneva' },
                    { 'val': 'Georgia', 'text': 'Georgia' },
                    { 'val': 'Helvetica', 'text': 'Helvetica' },
                    { 'val': 'Sans-serif', 'text': 'Sans-serif' },
                    { 'val': 'Serif', 'text': 'Serif' },
                    { 'val': 'Trebuchet MS', 'text': 'Trebuchet MS' },
                    { 'val': 'Verdana', 'text': 'Verdana' }
                ]
            }),
            ratingsStore = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': 1, 'text': '1' },
                    { 'val': 2, 'text': '2' },
                    { 'val': 3, 'text': '3' },
                    { 'val': 4, 'text': '4' },
                    { 'val': 5, 'text': '5' }
                ]
            }),
            betterThanStore = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': '0.0', 'text': '0.0' },
                    { 'val': '0.5', 'text': '0.5' },
                    { 'val': '1.0', 'text': '1.0' },
                    { 'val': '1.5', 'text': '1.5' },
                    { 'val': '2.0', 'text': '2.0' },
                    { 'val': '2.5', 'text': '2.5' },
                    { 'val': '3.0', 'text': '3.0' },
                    { 'val': '3.5', 'text': '3.5' },
                    { 'val': '4.0', 'text': '4.0' },
                    { 'val': '4.5', 'text': '4.5' },
                    { 'val': '5.0', 'text': '5.0' }

                ]
            }),
            richSnippetsPositions = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': 'listing', 'text': me.snippets.richSnippetsCategory },
                    { 'val': 'detail', 'text': me.snippets.richSnippetsProduct },
                    { 'val': 'index', 'text': me.snippets.richSnippetsHome }
                ]
            });


        var items = [
            {
                xtype: 'container',
                padding: 10,
                layout: 'anchor',
                defaults: {
                    anchor: '100%',
                    width: 450,
                    labelWidth: 250
                },
                items: [

                    {
                        name: 'trustbadgeSettingsFieldset',
                        xtype: 'fieldset',
                        columnWidth: '100%',
                        title: me.snippets.trustBadgeLabel,
                        collapsible: true,
                        defaultType: 'textfield',
                        defaults: {
                            anchor: '100%',
                            labelWidth: 250
                        },
                        style: {
                            background: '#EAEAEA',
                            margin: '20px 0px 0px 0px'
                        },
                        layout: 'anchor',
                        items: [
                            {
                                xtype: 'combobox',
                                name: 'badgeVariant',
                                store: badgeVariant,
                                displayField: 'variantText',
                                valueField: 'variantVal',
                                queryMode: 'local',
                                fieldLabel: me.snippets.badgeVariantLabel,
                                forceSelection: true,
                                editable: false,

                            },
                            {
                                xtype: 'numberfield',
                                name: 'yOffset',
                                minValue: 0,
                                fieldLabel: me.snippets.yOffset,
                                helpText: me.snippets.yOffsetHelpText
                            }
                        ]
                    },
                    {
                        name: 'collectRatingsFieldset',
                        xtype: 'fieldset',
                        columnWidth: '100%',
                        title: me.snippets.collectRatingsFieldset,
                        defaultType: 'textfield',
                        defaults: {
                            anchor: '100%',
                            labelWidth: 250
                        },
                        style: {
                            background: '#EAEAEA',
                            margin: '20px 0px 0px 0px'
                        },
                        layout: 'anchor',
                        items: [
                            {
                                xtype: 'combobox',
                                name: 'collectRatings',
                                store: collectRatingsStore,
                                displayField: 'variantText',
                                valueField: 'variantVal',
                                value: false,
                                queryMode: 'local',
                                fieldLabel: me.snippets.collectRatingsLabel,
                                forceSelection: true,
                                editable: false,
                                listeners: {
                                    change: function (comboBox, newValue) {
                                        me.fireEvent('onEnableRatingsCollection', me, newValue);
                                    }
                                }
                            },
                            {
                                xtype: 'panel',
                                border: false,
                                html: me.snippets.collectRatingsDescription
                            }
                        ]
                    },
                    {
                        name: 'productReviewStickerFieldset',
                        xtype: 'fieldset',
                        columnWidth: '100%',
                        title: me.snippets.prodReviewStickerTitle,
                        collapsible: true,
                        defaultType: 'textfield',
                        hidden: true,
                        defaults: {
                            anchor: '100%',
                            labelWidth: 250
                        },
                        style: {
                            background: '#EAEAEA',
                            margin: '20px 0px 0px 0px'
                        },
                        layout: 'anchor',
                        items: [

                            {
                                xtype: 'combobox',
                                name: 'trustedShopsShowReviewStickerActive',
                                store: showRating,
                                displayField: 'text',
                                valueField: 'val',
                                value: false,
                                queryMode: 'local',
                                fieldLabel: me.snippets.prodReviewStickerSwitch,
                                forceSelection: true,
                                editable: false,
                                listeners: {
                                    change: function (comboBox, newValue) {
                                        me.fireEvent('onChangeStickerSwitch', me, newValue);
                                    }
                                }
                            },
                            {
                                xtype: 'textfield',
                                name: 'prodReviewStickerTabName',
                                disabled: true,
                                fieldLabel: me.snippets.prodReviewStickerTabName,
                                helpText: me.snippets.prodReviewStickerTabNameHelpText,
                            },

                            {
                                xtype: 'textfield',
                                name: 'prodStickerBorderColor',
                                // regex: /^\#[0-9A-F]{6}$/i,
                                disabled: true,
                                allowBlank: false,
                                fieldLabel: me.snippets.prodReviewStickerBorderColor,
                            },
                            {
                                xtype: 'textfield',
                                name: 'prodStickerStarColor',
                                // regex: /^\#[0-9A-F]{6}$/i,
                                disabled: true,
                                allowBlank: false,
                                fieldLabel: me.snippets.prodReviewStickerStarColor,
                            },
                            {
                                xtype: 'textfield',
                                name: 'reviewStickerBackgroundColor',
                                disabled: true,
                                allowBlank: false,
                                fieldLabel: me.snippets.prodReviewStickerBackgroundColor,

                            },
                            {
                                xtype: 'numberfield',
                                name: 'reviewStickerStarSize',
                                disabled: true,
                                minValue: 1,
                                maxValue: 150,
                                value: 15,
                                fieldLabel: me.snippets.prodReviewStickerStarSize,

                            },
                        ]
                    },
                    {
                        name: 'productReviewStarsFieldset',
                        xtype: 'fieldset',
                        columnWidth: '100%',
                        title: me.snippets.prodReviewStarsTitle,
                        collapsible: true,
                        defaultType: 'textfield',
                        hidden: true,
                        defaults: {
                            anchor: '100%',
                            labelWidth: 250
                        },
                        style: {
                            background: '#EAEAEA',
                            margin: '20px 0px 0px 0px'
                        },
                        layout: 'anchor',
                        items: [
                            {
                                xtype: 'combobox',
                                name: 'trustedShopsShowRatingsStarsActive',
                                store: showStars,
                                displayField: 'text',
                                valueField: 'val',
                                value: false,
                                queryMode: 'local',
                                fieldLabel: me.snippets.prodReviewStarsSwitch,
                                forceSelection: true,
                                editable: false,
                                listeners: {
                                    change: function (comboBox, newValue) {
                                        me.fireEvent('onChangeStarsSwitch', me, newValue);
                                    }
                                }
                            },
                            {
                                xtype: 'checkbox',
                                name: 'hideEmptyStarRatings',
                                uncheckedValue: 0,
                                inputValue: 1,
                                disabled: true,
                                fieldLabel: me.snippets.hideEmptyStarRatingsLabel,
                                helpText: me.snippets.emptyStarsHelpText
                            },
                            {
                                xtype: 'textfield',
                                disabled: true,
                                name: 'starColor',
                                allowBlank: false,
                                fieldLabel: me.snippets.prodReviewStarColor,

                            },
                            {
                                xtype: 'numberfield',
                                name: 'starSize',
                                disabled: true,
                                minValue: 1,
                                maxValue: 150,
                                value: 14,
                                fieldLabel: me.snippets.prodReviewStarSize,

                            },
                            {
                                xtype: 'numberfield',
                                name: 'fontSize',
                                disabled: true,
                                minValue: 1,
                                maxValue: 150,
                                value: 12,
                                fieldLabel: me.snippets.prodReviewFontSize,

                            }
                        ]
                    },
                    {
                        name: 'configureMoreProductsFieldset',
                        xtype: 'fieldset',
                        columnWidth: '100%',
                        title: me.snippets.configureMoreProductsFieldsetTitle,
                        collapsible: true,
                        defaultType: 'textfield',
                        defaults: {
                            anchor: '100%',
                            labelWidth: 250
                        },
                        style: {
                            background: '#EAEAEA',
                            margin: '20px 0px 0px 0px'
                        },
                        layout: 'anchor',
                        items: [
                            {
                                name: 'trustedShopsCustomerRatings',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.customerRatingsLabel,
                                collapsible: true,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 250
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'panel',
                                        border: false,
                                        html: me.snippets.customerRatingsExtratext,
                                        style: {
                                            margin: '0px 0px 20px 0px'
                                        }
                                    },
                                    {
                                        xtype: 'combobox',
                                        name: 'customerRatingsActive',
                                        store: activateCustomerRatings,
                                        displayField: 'text',
                                        valueField: 'val',
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.customerRatingsActive,
                                        forceSelection: true,
                                        editable: false,
                                        listeners: {
                                            change: function (comboBox, newValue) {
                                                me.fireEvent('onEnableCustomerRatings', me, newValue);
                                            }
                                        }

                                    },
                                    {
                                        xtype: 'combobox',
                                        name: 'customerRatingsFontFamily',
                                        store: fontsStore,
                                        displayField: 'text',
                                        valueField: 'val',
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.customerRatingsFontFamily,
                                        forceSelection: true,
                                        editable: false,

                                    },
                                    {
                                        xtype: 'combobox',
                                        name: 'customerRatingsReviews',
                                        store: ratingsStore,
                                        displayField: 'text',
                                        valueField: 'val',
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.customerRatingsReviews,
                                        forceSelection: true,
                                        editable: false,

                                    },
                                    {
                                        xtype: 'combobox',
                                        name: 'customerRatingsBetterThan',
                                        store: betterThanStore,
                                        displayField: 'text',
                                        valueField: 'val',
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.customerRatingsBetterThan,
                                        forceSelection: true,
                                        editable: false,

                                    },
                                    {
                                        xtype: 'textfield',
                                        name: 'customerRatingsBackgroundColor',
                                        allowBlank: false,
                                        fieldLabel: me.snippets.customerRatingsBackgroundColor,
                                    },

                                ]
                            },
                            {
                                name: 'richSnippets',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.richSnippets,
                                collapsible: true,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 250
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'checkbox',
                                        name: 'richSnippetsActive',
                                        uncheckedValue: 0,
                                        inputValue: 1,
                                        fieldLabel: me.snippets.richSnippetsActive,
                                        helpText: me.snippets.richSnippetsHelpText,
                                        listeners: {
                                            change: function (checkbox, newValue) {
                                                me.fireEvent('onEnableRichSnippets', me, newValue);
                                            }
                                        }
                                    },
                                    {
                                        xtype: 'hiddenfield',
                                        name: 'richSnippetsLocations',
                                        id: 'richSnippetsLocations',
                                        style: {
                                            display: 'none'
                                        },
                                    },
                                    {
                                        xtype: 'checkboxgroup',
                                        name: 'richSnippetsLocationsList',
                                        id: 'richSnippetsLocationsList',
                                        fieldLabel: me.snippets.richSnippetsOn,
                                        vertical: true,
                                        disabled: true,
                                        columns: 1,
                                        listeners: {
                                            change: function (element, selectedCheckboxes, checkboxesClicked) {
                                                selectedRichSnippetsLocations = Ext.getCmp('richSnippetsLocations');
                                                selctedLocations = [];
                                                Object.keys(selectedCheckboxes).forEach(function (key, val) {
                                                    selctedLocations.push(selectedCheckboxes[ key ]);
                                                });
                                                selectedRichSnippetsLocations.setValue(selctedLocations);
                                            }
                                        },

                                        items: [ {
                                            xtype: 'checkboxfield',
                                            boxLabel: me.snippets.richSnippetsCategory,
                                            inputValue: 'listing',
                                            uncheckedValue: '',
                                            scope: this
                                        }, {
                                            xtype: 'checkboxfield',
                                            boxLabel: me.snippets.richSnippetsProduct,
                                            inputValue: 'detail',
                                            uncheckedValue: ''
                                        }, {
                                            xtype: 'checkboxfield',
                                            boxLabel: me.snippets.richSnippetsHome,
                                            inputValue: 'index',
                                            uncheckedValue: ''
                                        }
                                        ]
                                    },
                                ]
                            },
                        ]

                    },
                    {
                        name: 'deliveryTimeSettingsFieldset',
                        xtype: 'fieldset',
                        columnWidth: '100%',
                        title: me.snippets.deliveryTimeTitle,
                        collapsible: true,
                        defaultType: 'textfield',
                        defaults: {
                            anchor: '100%',
                            labelWidth: 250
                        },
                        style: {
                            background: '#EAEAEA',
                            margin: '20px 0px 0px 0px'
                        },
                        layout: 'anchor',
                        items: [
                            {
                                xtype: 'radiogroup',
                                fieldLabel: me.snippets.deliveryTimeSettingsAvailableProduct,
                                defaultType: 'radiofield',
                                defaults: {
                                    flex: 1
                                },
                                layout: 'hbox',
                                listeners: {
                                    change: function (radio, newValue) {
                                        me.fireEvent('onChangeDeliveryTimeOfProduct', me, newValue);
                                    }
                                },
                                items: [
                                    {
                                        boxLabel: me.snippets.deliveryTimeAsDefined,
                                        name: 'deliveryTimeOfProduct',
                                        inputValue: 'product',
                                        checked: true,
                                        id: 'productStandard',
                                        bubbleEvents: true
                                    }, {
                                        boxLabel: me.snippets.fixedDeliveryTime,
                                        name: 'deliveryTimeOfProduct',
                                        inputValue: 'custom',
                                        id: 'customStandard',
                                        bubbleEvents: true
                                    }
                                ]

                            },
                            {
                                xtype: 'numberfield',
                                name: 'trustedShopsInStockDeliveryTime',
                                fieldLabel: me.snippets.inStockDeliveryTime,
                                minValue: 0,
                                maxValue: 100,
                                hidden: true,
                                helpText: me.snippets.inStockDeliveryTimeHelpText,
                                style: {
                                    marginBottom: '10px'
                                }
                            },
                            {
                                xtype: 'radiogroup',
                                fieldLabel: me.snippets.deliveryTimeSettingsNAProduct,
                                defaultType: 'radiofield',
                                defaults: {
                                    flex: 1
                                },
                                layout: 'hbox',
                                listeners: {
                                    change: function (radio, newValue) {
                                        me.fireEvent('onChangeNaDeliveryTimeOfProduct', me, newValue);
                                    }
                                },
                                items: [
                                    {
                                        boxLabel: me.snippets.deliveryTimeAsDefined,
                                        name: 'naDeliveryTimeOfProduct',
                                        inputValue: 'product',
                                        checked: true,
                                        id: 'naProductStandard',
                                        bubbleEvents: true
                                    }, {
                                        boxLabel: me.snippets.fixedDeliveryTime,
                                        name: 'naDeliveryTimeOfProduct',
                                        inputValue: 'custom',
                                        id: 'naCustomStandard',
                                        bubbleEvents: true
                                    }
                                ]

                            },
                            {
                                xtype: 'numberfield',
                                name: 'trustedShopsNotInStockDeliveryTime',
                                fieldLabel: me.snippets.notInStockDeliveryTime,
                                minValue: 0,
                                maxValue: 100,
                                hidden: true,
                                helpText: me.snippets.notInStockDeliveryTimeHelpText,
                                style: {
                                    marginBottom: '10px'
                                }
                            }
                        ]
                    }
                ]
            }
        ];

        return items;
    },

    /**
     * Registering events fired on "Register button click" and "switching expert/standardmode"
     */
    registerEvents: function () {
        this.addEvents(
            'onChangeStarsSwitch',
            'onChangeStickerSwitch',
            'onEnableRatingsCollection'
        );
    }
});
// {/block}

