
//{namespace name="trusted_shops_badge"}

//{block name="backend/trusted_shops_badge/view/expert"}
Ext.define('Shopware.apps.TrustedShopsBadge.view.main.Expert', {
    extend: 'Ext.container.Container',
    alias: 'widget.trustedShops-main-expert',

    /**
     * Contains all snippets for the expert Tab
     * @object
     */
    snippets: {
        trustedShopsTrustBadgeCode: '{s name=expert/trustedShopsTrustBadgeCode}{/s}',
        expertPaneTitle: '{s name=expert/expertPaneTitle}{/s}',
        prodReviewStickerCode: '{s name=expert/prodReviewStickerCode}{/s}',
        prodReviewStickerCodeEmptyText: '{s name=expert/prodReviewStickerCodeEmptyText}{/s}',
        prodReviewStarsCode: '{s name=expert/prodReviewStarsCode}{/s}',
        prodReviewStarsEmptyText: '{s name=expert/prodReviewStarsEmptyText}{/s}',
        expertModeDescriptionText: '{s name=expert/expertModeDescriptionText}{/s}',
        trustedShopsTrustBadgeCodeHelpText: '{s name=expert/trustedShopsTrustBadgeCodeHelpText}{/s}',
        trustedShopsProductStickerCodeHelpText: '{s name=expert/trustedShopsProductStickerCodeHelpText}{/s}',
        trustedShopsProductWidgetCodeHelpText: '{s name=expert/trustedShopsProductWidgetCodeHelpText}{/s}',
        yesComboOption: '{s name=expert/yesComboOption}{/s}',
        noComboOption: '{s name=expert/noComboOption}{/s}',
        collectRatingsLabel: '{s name=expert/collectRatingsLabel}{/s}',
        collectRatingsDescription: '{s name=expert/collectRatingsDescription}{/s}',
        prodReviewStickerSwitch: '{s name=expert/prodReviewStickerSwitch}{/s}',
        prodReviewStarsSwitch: '{s name=expert/prodReviewStarsSwitch}{/s}',
        prodReviewStickerTabName: '{s name=expert/prodReviewStickerTabName}{/s}',
        deliveryTimeTitle: '{s name=expert/deliveryTimeTitle}{/s}',
        inStockDeliveryTime: '{s name=expert/inStockDeliveryTime}{/s}',
        notInStockDeliveryTime: '{s name=expert/notInStockDeliveryTime}{/s}',
        inStockDeliveryTimeHelpText: '{s name=expert/inStockDeliveryTimeHelpText}{/s}',
        notInStockDeliveryTimeHelpText: '{s name=expert/notInStockDeliveryTimeHelpText}{/s}',
        deliveryTimeSettingsAvailableProductExpert: '{s name=badge/deliveryTimeSettingsAvailableProduct}{/s}',
        deliveryTimeSettingsNAProductExpert: '{s name=badge/deliveryTimeSettingsNAProduct}{/s}',
        deliveryTimeAsDefinedExpert: '{s name=badge/deliveryTimeAsDefined}{/s}',
        fixedDeliveryTimeExpert: '{s name=badge/fixedDeliveryTime}{/s}',
        customerRatingsActiveExpert: '{s name=badge/customerRatingsActive}{/s}',
        customerRatingsExpertCodeLabel: '{s name=expert/customerRatingsExpertCodeLabel}{/s}',
        customerRatingsExpertCodeHelpText: '{s name=expert/customerRatingsExpertCodeHelpText}{/s}',
        customerRatingsExpertCodeEmptyText: '{s name=expert/customerRatingsExpertCodeEmptyText}{/s}',
        ratingStarsSelectorHelpText: '{s name=expert/ratingStarsSelectorHelpText}{/s}',
        prodReviewStickerSelectorHelpText: '{s name=expert/prodReviewStickerSelectorHelpText}{/s}',
        customerRatingsSelectorHelpText: '{s name=expert/customerRatingsSelectorHelpText}{/s}',
        richSnippetsActiveExpert: '{s name=badge/richSnippetsActive}{/s}',
        richSnippetsCategoryExpert: '{s name=badge/richSnippetsCategory}{/s}',
        richSnippetsProductExpert: '{s name=badge/richSnippetsProduct}{/s}',
        richSnippetsHomeExpert: '{s name=badge/richSnippetsHome}{/s}',
        richSnippetsHelpTextExpert: '{s name=badge/richSnippetsHelpText}{/s}',
        richSnippetsOnExpert: '{s name=badge/richSnippetsOn}{/s}',
        richSnippetsExpertCodeText: '{s name=expert/richSnippetsExpertCodeText}{/s}',
        richSnippetsExpertCodeEmptyText: '{s name=expert/richSnippetsExpertCodeEmptyText}{/s}',
        configureMoreProductsExpertFieldsetTitle: '{s name=badge/configureMoreProductsExpertFieldsetTitle}{/s}',
        prodReviewStickerTabNameHelpText: '{s name=expert/prodReviewStickerTabNameHelpText}{/s}',
        trustBadgeExpertLabel: '{s name=expert/trustBadgeExpertLabel}{/s}',
        collectRatingsExpertFieldsetLabel: '{s name=expert/collectRatingsExpertFieldsetLabel}{/s}',
        reviewStickerExpertFieldsetLabel: '{s name=expert/reviewStickerExpertFieldsetLabel}{/s}',
        ratingStarsExpertFieldsetLabel: '{s name=expert/ratingStarsExpertFieldsetLabel}{/s}',



    },

    /**
     * Sets up the ui component
     *
     * @return void
     */
    initComponent: function () {
        var me = this;

        me.items = me.getItems();

        me.callParent(arguments);
    },

    /**
     * Creates items shown in form panel
     *
     * @return array
     */
    getItems: function () {
        var me = this,
            collectRatingsStore = Ext.create('Ext.data.Store', {
                fields: [
                    'variantVal',
                    'variantText'
                ],
                data: [
                    { variantVal: true, variantText: me.snippets.yesComboOption },
                    { variantVal: false, variantText: me.snippets.noComboOption }

                ]
            }),
            showRating = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': true, 'text': me.snippets.yesComboOption },
                    { 'val': false, 'text': me.snippets.noComboOption }

                ]
            }),
            showStars = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': true, 'text': me.snippets.yesComboOption },
                    { 'val': false, 'text': me.snippets.noComboOption }
                ]
            }),
            showCustomerRatings = Ext.create('Ext.data.Store', {
                fields: [
                    'val',
                    'text'
                ],
                data: [
                    { 'val': true, 'text': me.snippets.yesComboOption },
                    { 'val': false, 'text': me.snippets.noComboOption }
                ]
            });

        Ext.getBody().on('click', function (event, target) {
            event.preventDefault();
            tsTestLink = target.getAttribute('href');
            tsTestLink = tsTestLink.replace('__TSID__', Ext.getCmp('trustedShopsId').getValue());
            window.location.href = tsTestLink;
        }, null, {
            delegate: '#testTrustedShopsSettings'
        });

        var items = [
            {
                xtype: 'container',
                padding: 10,
                layout: 'anchor',
                defaults: {
                    anchor: '100%',
                    width: 450,
                    labelWidth: 150
                },
                items: [
                    {
                        id: 'expertSettingsFieldset',
                        xtype: 'fieldset',
                        columnWidth: '100%',
                        defaultType: 'textfield',
                        defaults: {
                            anchor: '100%',
                            labelWidth: 150
                        },
                        style: {
                            background: '#EAEAEA'
                        },
                        items: [
                            {
                                xtype: 'panel',
                                border: false,
                                html: me.snippets.expertModeDescriptionText,
                            },
                            {
                                name: 'trustbadgeSettingsExpertFieldset',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.trustBadgeExpertLabel,
                                collapsible: true,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 180
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'textarea',
                                        name: 'trustedShopsTrustBadgeCode',
                                        fieldLabel: me.snippets.trustedShopsTrustBadgeCode,
                                        grow: true,
                                        allowBlank: false,
                                        growMin: 190,
                                        emptyText: me.snippets.trustedShopsTrustBadgeCodeEmptyText,
                                        helpText: me.snippets.trustedShopsTrustBadgeCodeHelpText
                                    },
                                ]
                            },
                            {
                                name: 'collectRatingsExpertFieldset',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.collectRatingsExpertFieldsetLabel,
                                collapsible: false,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 180
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'combobox',
                                        name: 'collectRatingsExpert',
                                        store: collectRatingsStore,
                                        displayField: 'variantText',
                                        valueField: 'variantVal',
                                        value: false,
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.collectRatingsLabel,
                                        forceSelection: true,
                                        editable: false,
                                        listeners: {
                                            change: function (comboBox, newValue) {
                                                me.fireEvent('onEnableRatingsCollectionExpert', me, newValue);
                                            }
                                        }
                                    }
                                ]
                            },
                            {
                                name: 'trustedShopsReviewStickerExpertFieldset',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.reviewStickerExpertFieldsetLabel,
                                collapsible: true,
                                hidden: true,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 180
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'combobox',
                                        name: 'trustedShopsShowReviewStickerActiveExpert',
                                        store: showRating,
                                        displayField: 'text',
                                        valueField: 'val',
                                        value: false,
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.prodReviewStickerSwitch,
                                        forceSelection: true,
                                        editable: false,
                                        listeners: {
                                            change: function (comboBox, newValue) {
                                                me.fireEvent('onChangeStickerSwitchExpert', me, newValue);
                                            }
                                        }
                                    },
                                    {
                                        xtype: 'textfield',
                                        name: 'prodReviewStickerTabNameExpert',
                                        fieldLabel: me.snippets.prodReviewStickerTabName,
                                        disabled: true,
                                        helpText: me.snippets.prodReviewStickerTabNameHelpText
                                    },
                                    {
                                        xtype: 'textarea',
                                        name: 'trustedShopsShowReviewStickerCode',
                                        fieldLabel: me.snippets.prodReviewStickerCode,
                                        grow: true,
                                        allowBlank: false,
                                        growMin: 190,
                                        emptyText: me.snippets.prodReviewStickerCodeEmptyText,
                                        helpText: me.snippets.trustedShopsProductStickerCodeHelpText,
                                        disabled: true
                                    },
                                    {
                                        xtype: 'textfield',
                                        name: 'reviewStickerSelector',
                                        fieldLabel: 'jQuery selector',
                                        disabled: true,
                                        helpText: me.snippets.prodReviewStickerSelectorHelpText

                                    }
                                ]
                            },
                            {
                                name: 'trustedShopsRatingStarsExpertFieldset',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.ratingStarsExpertFieldsetLabel,
                                collapsible: true,
                                hidden: true,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 180
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'combobox',
                                        name: 'trustedShopsShowRatingsStarsActiveExpert',
                                        store: showStars,
                                        displayField: 'text',
                                        valueField: 'val',
                                        value: false,
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.prodReviewStarsSwitch,
                                        forceSelection: true,
                                        editable: false,
                                        listeners: {
                                            change: function (comboBox, newValue) {
                                                me.fireEvent('onChangeStarsSwitchExpert', me, newValue);
                                            }
                                        }
                                    },
                                    {
                                        xtype: 'textarea',
                                        itemId: 'trustedShopsShowRatingsStarsCode',
                                        name: 'trustedShopsShowRatingsStarsCode',
                                        fieldLabel: me.snippets.prodReviewStarsCode,
                                        grow: true,
                                        allowBlank: false,
                                        growMin: 190,
                                        emptyText: me.snippets.prodReviewStarsEmptyText,
                                        helpText: me.snippets.trustedShopsProductWidgetCodeHelpText,
                                        disabled: true
                                    },
                                    {
                                        xtype: 'textfield',
                                        name: 'reviewStarsSelector',
                                        fieldLabel: 'jQuery selector',
                                        disabled: true,
                                        helpText: me.snippets.ratingStarsSelectorHelpText
                                    },
                                ]
                            },
                            //----------------------------------------------------------------------------------------------------
                            {
                                name: 'configureMoreProductsExpertFieldset',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.configureMoreProductsExpertFieldsetTitle,
                                collapsible: true,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 180
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'combobox',
                                        name: 'customerRatingsActiveExpert',
                                        store: showCustomerRatings,
                                        displayField: 'text',
                                        valueField: 'val',
                                        value: false,
                                        queryMode: 'local',
                                        fieldLabel: me.snippets.customerRatingsActiveExpert,
                                        forceSelection: true,
                                        editable: false,
                                        listeners: {
                                            change: function (comboBox, newValue) {
                                                me.fireEvent('onChangeCustomerRatingsActiveExpert', me, newValue);
                                            }
                                        }
                                    },
                                    {
                                        xtype: 'textarea',
                                        itemId: 'customerRatingsExpertCode',
                                        name: 'customerRatingsExpertCode',
                                        fieldLabel: me.snippets.customerRatingsExpertCodeLabel,
                                        grow: true,
                                        allowBlank: false,
                                        growMin: 190,
                                        emptyText: me.snippets.customerRatingsExpertCodeEmptyText,
                                        helpText: me.snippets.customerRatingsExpertCodeHelpText,
                                        disabled: true
                                    },
                                    {
                                        xtype: 'textfield',
                                        name: 'customerReviewsSelector',
                                        fieldLabel: 'jQuery selector',
                                        disabled: true,
                                        helpText: me.snippets.customerRatingsSelectorHelpText
                                    },
                                    {
                                        xtype: 'checkbox',
                                        name: 'richSnippetsActiveExpert',
                                        uncheckedValue: 0,
                                        inputValue: 1,
                                        fieldLabel: me.snippets.richSnippetsActiveExpert,
                                        helpText: me.snippets.richSnippetsHelpTextExpert,
                                        listeners: {
                                            change: function (checkbox, newValue) {
                                                me.fireEvent('onEnableRichSnippetsExpert', me, newValue);
                                            }
                                        }
                                    },

                                    {
                                        xtype: 'hiddenfield',
                                        name: 'richSnippetsLocationsExpert',
                                        id: 'richSnippetsLocationsExpert',
                                        style: {
                                            display: 'none'
                                        },
                                    },
                                    {
                                        xtype: 'checkboxgroup',
                                        name: 'richSnippetsLocationsListExpert',
                                        id: 'richSnippetsLocationsListExpert',
                                        fieldLabel: me.snippets.richSnippetsOnExpert,
                                        vertical: true,
                                        columns: 1,
                                        disabled: true,
                                        listeners: {
                                            change: function (element, selectedCheckboxes, checkboxesClicked) {
                                                selectedRichSnippetsLocations = Ext.getCmp('richSnippetsLocationsExpert');
                                                selctedLocations = [];
                                                Object.keys(selectedCheckboxes).forEach(function (key, val) {
                                                    selctedLocations.push(selectedCheckboxes[ key ]);
                                                });
                                                selectedRichSnippetsLocations.setValue(selctedLocations);
                                            }
                                        },

                                        items: [ {
                                            xtype: 'checkboxfield',
                                            boxLabel: me.snippets.richSnippetsCategoryExpert,
                                            inputValue: 'listing',
                                            scope: this,
                                            uncheckedValue: ''
                                        }, {
                                            xtype: 'checkboxfield',
                                            boxLabel: me.snippets.richSnippetsProductExpert,
                                            inputValue: 'detail',
                                            uncheckedValue: ''
                                        }, {
                                            xtype: 'checkboxfield',
                                            boxLabel: me.snippets.richSnippetsHomeExpert,
                                            inputValue: 'index',
                                            uncheckedValue: ''
                                        }
                                        ]
                                    },
                                    {
                                        xtype: 'textarea',
                                        itemId: 'richSnippetsExpertCode',
                                        name: 'richSnippetsExpertCode',
                                        fieldLabel: me.snippets.richSnippetsExpertCodeText,
                                        grow: true,
                                        allowBlank: false,
                                        growMin: 190,
                                        emptyText: me.snippets.richSnippetsExpertCodeEmptyText,
                                        helpText: me.snippets.richSnippetsHelpTextExpert,
                                        disabled: true
                                    },
                                ]
                            },

                            {
                                name: 'deliveryTimeSettingsFieldsetExpert',
                                xtype: 'fieldset',
                                columnWidth: '100%',
                                title: me.snippets.deliveryTimeTitle,
                                collapsible: true,
                                defaultType: 'textfield',
                                defaults: {
                                    anchor: '100%',
                                    labelWidth: 250
                                },
                                style: {
                                    background: '#EAEAEA',
                                    margin: '20px 0px 0px 0px'
                                },
                                layout: 'anchor',
                                items: [
                                    {
                                        xtype: 'radiogroup',
                                        fieldLabel: me.snippets.deliveryTimeSettingsAvailableProductExpert,
                                        defaultType: 'radiofield',
                                        defaults: {
                                            flex: 1
                                        },
                                        layout: 'hbox',
                                        listeners: {
                                            change: function (radio, newValue) {
                                                me.fireEvent('onChangeDeliveryTimeOfProductExpert', me, newValue);
                                            }
                                        },
                                        items: [
                                            {
                                                boxLabel: me.snippets.deliveryTimeAsDefinedExpert,
                                                name: 'deliveryTimeOfProductExpert',
                                                inputValue: 'product',
                                                checked: true,
                                                id: 'productStandardExpert',
                                                bubbleEvents: true
                                            }, {
                                                boxLabel: me.snippets.fixedDeliveryTimeExpert,
                                                name: 'deliveryTimeOfProductExpert',
                                                inputValue: 'custom',
                                                id: 'customStandardExpert',
                                                bubbleEvents: true
                                            }
                                        ]

                                    },
                                    {
                                        xtype: 'numberfield',
                                        name: 'trustedShopsInStockDeliveryTimeExpert',
                                        fieldLabel: me.snippets.inStockDeliveryTime,
                                        minValue: 0,
                                        maxValue: 100,
                                        helpText: me.snippets.inStockDeliveryTimeHelpText,
                                        hidden: true,
                                        style: {
                                            marginBottom: '10px'
                                        }
                                    },
                                    {
                                        xtype: 'radiogroup',
                                        fieldLabel: me.snippets.deliveryTimeSettingsNAProductExpert,
                                        defaultType: 'radiofield',
                                        defaults: {
                                            flex: 1
                                        },
                                        layout: 'hbox',
                                        listeners: {
                                            change: function (radio, newValue) {
                                                me.fireEvent('onChangeNaDeliveryTimeOfProductExpert', me, newValue);
                                            }
                                        },
                                        items: [
                                            {
                                                boxLabel: me.snippets.deliveryTimeAsDefinedExpert,
                                                name: 'naDeliveryTimeOfProductExpert',
                                                inputValue: 'product',
                                                checked: true,
                                                id: 'naProductStandardExpert',
                                                bubbleEvents: true
                                            }, {
                                                boxLabel: me.snippets.fixedDeliveryTimeExpert,
                                                name: 'naDeliveryTimeOfProductExpert',
                                                inputValue: 'custom',
                                                id: 'naCustomStandardExpert',
                                                bubbleEvents: true
                                            }
                                        ]

                                    },
                                    {
                                        xtype: 'numberfield',
                                        name: 'trustedShopsNotInStockDeliveryTimeExpert',
                                        fieldLabel: me.snippets.notInStockDeliveryTime,
                                        minValue: 0,
                                        maxValue: 100,
                                        helpText: me.snippets.notInStockDeliveryTimeHelpText,
                                        hidden: true,
                                        style: {
                                            marginBottom: '10px'
                                        }
                                    }
                                ]
                            }
                        ]
                    }
                ]
            }
        ];
        return items;
    },
    registerEvents: function () {
        this.addEvents(
            'onEnableRatingsCollectionExpert',
            'onChangeStarsSwitchExpert',
            'onChangeStickerSwitchExpert'
        );
    }
});
//{/block}